kvmtool(1)

NAME
kvmtool - running KVM guests

SYNOPSIS
lkvm COMMAND [ARGS]

DESCRIPTION
kvmtool is a userland tool for creating and controlling KVM guests.

KVMTOOL COMMANDS

run -k <kernel-image> [-c <cores>] [-m <MiB>] [-p <command line>]
[-i <initrd>] [-d <image file>] [--console serial|virtio|hv]
[--dev <node>] [--debug] [--debug-single-step] [--debug-ioport]
    Run a guest.

    -k, --kernel <image file>
        The virtual machine kernel.

    -c, --cpus <n>
        The number of virtual CPUs to run.

    -m, --mem <n>
        Virtual machine memory size in MiB.

    -p, --params <parameters>
        Additional kernel command line arguments.

    -i, --initrd <image file>
        Initial RAM disk image.

    -d, --disk <image file|directory>
        A disk image file or a rootfs directory.

    --console serial|virtio|hv
        Console to use.

    --dev <device node>
        KVM device file (instead of the default /dev/kvm).

    --debug
        Enable debug messages.

    --debug-single-step
        Enable single stepping.

    --debug-ioport
        Enable ioport debugging.

setup <name>
    Setup a new virtual machine. This creates a new rootfs in the .lkvm folder of your home directory.

pause --all|--name <name>
    Pause a virtual machine.

    -a, --all
        Pause all running instances.

    -n, --name <name>
        Pause that specified instance. For a list of running instances, see lkvm list.

resume --all|--name <name>
    Resume a previously paused virtual machine.

    -a, --all
        Resume all running instances.

    -n, --name <name>
        Resume that specified instance. For a list of running instances, see lkvm list.

list [-i] [-r]
    Print a list of running instances on the host. This is restricted to instances started by the current user, as it looks in the .lkvm folder in your home directory to find the socket files.

    -i, --run
        List all running instances.

    -r, --rootfs
        List rootfs instances.

debug --all|--name <guest name> [--dump] [--nmi <n>] [--sysrq <rq>]
    Print debug information from a running VM instance.

    -a, --all
        Debug all running instances.

    -n, --name <guest name>
        Debug the specified instance.

    -d, --dump
        Generate a debug dump from guest.

    -m, --nmi <VCPU nr>
        Generate an NMI on the specified virtual CPU.

    -s, --sysrq <sysrq>
        Inject a Linux sysrq into the guest.

balloon --name <guest name> --inflate|--deflate <amount in MB>
    This command inflates or deflates the virtio balloon located in the specified instance. --inflate increases the size of the balloon, thus decreasing the amount of virtual RAM available for the guest. --deflate returns previously inflated memory back to the guest.

    -n, --name <guest name>
        Ballon the specified instance. For a list of all instances, see "lkvm list".

    -i, --inflate <n>
        Inflates the ballon by the specified number of Megabytes. This decreases the amount of usable memory in the guest.

    -d, --deflate <n>
        Deflates the ballon by the specified number of Megabytes. This increases the amount of usable memory in the guest.

stop --all|--name <name>
    Stop a running instance.

    -a, --all
        Stop all running instances.

    -n, --name <name>
        Stop the specified instance. For a list of running instances, see lkvm list.

stat --all|--name <name> [-m]
    Print statistics about a running instance.

    -m, --memory
        Display memory statistics.

sandbox (lkvm run arguments) -- [sandboxed command]
    Run a command in a sandboxed guest. Kvmtool will inject a special init binary which will do an initial setup of the guest Linux and then lauch a shell script with the specified command. Upon this command ending, the guest will be shutdown.

EXAMPLES
    $ lkvm run -k bzImage

SEE ALSO
qemu(1), kvm(4)

BUGS

AUTHOR
Andre Przywara <andre.przywara@arm.com>